-- J. Craig Gilbert
-- cgilbert@cennet.mc.peachnet.edu
include graphics.e
include machine.e

sequence mregs
------------------------------------------------------------------------------
global procedure color(atom fore, atom back)
   text_color(fore)
   bk_color(back)
end procedure
------------------------------------------------------------------------------
global procedure teletype(integer char)
   if char > 255 or char < 0 then
      return
   end if
   mregs = repeat(0,10)
   mregs[REG_AX] = #0E00 + char
   mregs = dos_interrupt(#10,mregs)
end procedure
------------------------------------------------------------------------------
global function cursor_is_on()
-- note: at present this function only works for vid page 0
-- if you are on another page you will need to set
-- BX = (pagenum)*#100
   mregs = repeat(0,10)
   mregs[REG_AX] = #300
   mregs = dos_interrupt(#10,mregs)
   mregs[REG_CX] = and_bits(mregs[REG_CX],#1F1F) -- get rid of top 3 bits
                                                 -- in CH and CL
   if mregs[REG_CX] = 0 then  -- not on
      return 0    
   else -- is on
      return 1 
   end if
end function
------------------------------------------------------------------------------
global function get_cursor()
-- note: at present this function only works for vid page 0
-- if you are on another page you will need to set
-- BX = (pagenum)*#100
   mregs = repeat(0,10)
   mregs[REG_AX] = #300
   mregs = dos_interrupt(#10,mregs)
   mregs[REG_CX] = and_bits(mregs[REG_CX],#1F1F) -- get rid of top 3 bits
                                                 -- in CH and CL
   return mregs[REG_CX]
end function
------------------------------------------------------------------------------
global procedure set_cursor(integer shape)
-- CH=start of line
-- CL=end of line
-- only the low 5 bits of each byte are used
-- note: at present this function only works for vid page 0
-- if you are on another page you will need to set
-- BX = (pagenum)*#100
   mregs = repeat(0,10)
   mregs[REG_AX] = #100
   mregs[REG_CX] = shape
   mregs = dos_interrupt(#10,mregs)
end procedure
------------------------------------------------------------------------------
global procedure puts_at(integer row, integer col, sequence s)
   position(row, col)
   puts(1,s)
end procedure
------------------------------------------------------------------------------
global procedure wait()
integer c
c = wait_key()
end procedure
------------------------------------------------------------------------------

