-- zutil.e
-- ZIG utility functions

include machine.e
include graphics.e

global constant
    -- Exit code constants (used in EndProg() with abort(n))
    ERR_NO_GFX = 1, ERR_OTH_ERROR = 2, ERR_SAFE_PRG_EXIT = 0,
    ERR_INIT_ERROR = 3,
    
    -- Logic constants
    TRUE = 1, FALSE = 0, NULL = 0, ON = 1, OFF = 0,
    
    T_0 = 1, T_32 = 2, T_ALL = 3,
    
    -- Keyboard scancodes
    KEY_UP=328,KEY_DN=336,KEY_LF=331,KEY_RT=333,KEY_HOME=327,KEY_END=335,
    KEY_F1 = 315, KEY_F2 = 316, KEY_F3 = 317, KEY_F4 = 318, KEY_F5 = 319,
    KEY_F6 = 320, KEY_F7 = 321, KEY_F8 = 322, KEY_F9 = 323, KEY_F10 = 324,
    KEY_PGUP = 329,KEY_PGDN = 337,KEY_TAB = 9,KEY_ESC = 27,KEY_CR = 13,
    KEY_CT_UP=397,KEY_CT_DN=401,KEY_CT_LF=371,KEY_CT_RT=372,
    KEY_INS = 338, KEY_DEL = 339,
    KEY_ALT_UP = 408, KEY_ALT_DN = 416, KEY_ALT_LF = 411, KEY_ALT_RT = 413,
    
    text = allocate(21)     -- for allow_all_paledit()
    
-- This routine by David Cuny... thanks!
global procedure toggle_blinking(integer flag)
        sequence inReg, outReg

        inReg = repeat(0, 10)         -- initialize register list
        inReg[REG_AX] = #1003           -- function 10, subfunction 03
        inReg[REG_BX] = flag            -- enable/disable intensity
        outReg = dos_interrupt(#10, inReg)  -- bios call

end procedure

global procedure egachars()
    sequence regs
    regs = repeat(0, 10)
    regs[REG_AX] = #1201
    regs[REG_BX] = #0030
    regs = dos_interrupt(#10, regs)
    regs[REG_AX] = #0003
    regs = dos_interrupt(#10, regs)    
end procedure

-- This procedure allows editing of all palette colors (0-15)... thanks Pete!
global procedure allow_all_paledit ()
poke(text, {
#50,                    --    0: push eax
#52,                    --    1: push edx
#BA,#DA,#03,#00,#00,    --    2: mov edx,#3DA
#EC,                    --    7: in al,dx
#B2,#C0,                --    8: mov dl, #C0
#FA,                    --    A: cli
#B0,#00,                --    B: mov al, text_color (12)
#EE,                    --    D: out dx, al
#B0,#00,                --    E: mov al, index (15)
#EE,                    --   10: out dx, al
#FB,                    --   11: sti
#5A,                    --   12: pop edx
#58,                    --   13: pop eax
#C3})
for i = 0 to 15 do       -- this is the code you need
    poke(text + 12, i)   -- it makes colors 0-15 index into 
    poke(text + 15, i)   -- palette entries 0-15,
    call(text)           -- instead of 0-5,20,7,56-63
end for
poke(text + 12, #20) -- don't forget this or 
call(text)           -- the screen might be blank
end procedure

global function num2str(atom num)
    atom fn
    sequence ax

    ax = {}

    fn = open("delete.me","w")

    print(fn, num)
    close(fn)

    fn = open("delete.me","r")
    ax = gets(fn)
    close(fn)
    
    return(ax)
end function

global function str2num(sequence strcode)
    atom result, adder, mult
    result = 0
    
    for z = length(strcode) to 1 by -1 do
        if strcode[z] > 48 and strcode[z] < 60 then
            adder = 0
            if z = length(strcode) - 3 then
                mult = 1000
            elsif z = length(strcode) - 2 then
                mult = 100
            elsif z = length(strcode) - 1 then
                mult = 10
            elsif z = length(strcode) then
                mult = 1
            end if
            
            if adder = 0 then adder = 1 end if
        
            result = result + ((strcode[z] - 48) * mult)        
        end if
        
    end for
    
    return result
end function

global procedure EndProg(atom ExitCode)
    if graphics_mode(-1) then end if
    
    clear_screen()
    toggle_blinking(1)
    printf(1, "Exit code: %1d\n", ExitCode)
    puts(1, "Thank you for using ZIG.\n")
    
    abort(ExitCode)
end procedure

global function MBColRotate(atom Dummy3)
    if Dummy3 = 3 then
        Dummy3 = 7
    else Dummy3 = 3
    end if
    return Dummy3
end function

global function trim(sequence tt)
    atom Place
    
    if compare(tt, repeat(0, length(tt))) = 0
    or compare(tt, repeat(32, length(tt))) = 0 then
        return({})
    end if
    
    if tt[1] = 0 or tt[1] = 32 then
        for z = 1 to length(tt) do
            if tt[z] != 32 and tt[z] != 0 then
                Place = z
                exit
            end if
        end for
        tt = tt[Place..length(tt)]
    end if
    
    if tt[length(tt)] = 0 or tt[length(tt)] = 32 then
        Place = 0
        for z = length(tt) to 1 by -1 do
            if tt[z] != 32 and tt[z] != 0 then
                Place = z
                exit
            end if
        end for
        tt = tt[1..Place]
    end if
    
    return tt
end function

