-- z_txfr.e
-- ZIG Editor transfer operations module

-- transfer type codes:
-- 0: no transfer
-- 1: board
-- 2: palette
-- 3: charset
-- 4: object
-- 5-9: n/a
-- 10: ZZT world
-- 11: board, ASCII, no color
-- 12: board, ASCII, color (BLOAD)
-- 13: board, colors only (?)
-- 14: ZZT board file
-- 15: MZX palette
-- 16: MZX charset
-- 17: FM charset
-- 18: object (text file)
-- 19: world as text file desc
-- 20: world as text file desc, w/ boards (ASCII, no color)


global function DoTransfer(atom CurBoard)
    atom t_type, t_item, f
    sequence scroll, result
    object dummy
    
    result = DisplayScroll("Transfer Operations: Step 1",
                {"What transfer type?","",
                 "!" & 1 & ";Import",
                 "!" & 2 & ";Export","",
                 "ESC to cancel"}, 3)
                 
    if length(result) = 0 then
        return FALSE
    else t_type = result[1]
    end if

    result = DisplayScroll("Transfer Operations: Step 2",
                {"Item to import/export?","",
                 "!" & 1 & ";Board",
                 "!" & 2 & ";Palette",
                 "!" & 3 & ";Charset",
                 "!" & 4 & ";Object",
                 "!" & 9 & ";More items...","",
                 "ESC to cancel"}, 3)

    if length(result) = 0 then
        return FALSE
    elsif result[1] = 9 then
       result = DisplayScroll("Transfer Operations: Step 2 (more)",
                    {"Item to import/export?","",
                     "!" & 10 & ";ZZT world",
                     "!" & 1 & ";Board",
                     "!" & 11 & ";Board, ASCII (no color)",
                     "!" & 12 & ";Board, ASCII (color, BLOAD format compat.)",
                     "!" & 13 & ";Board, colors only",
                     "!" & 14 & ";ZZT board file (.BRD)",
                     "!" & 2 & ";Palette",
                     "!" & 15 & ";MegaZeux palette",
                     "!" & 3 & ";Charset",
                     "!" & 16 & ";MegaZeux charset",
                     "!" & 17 & ";Font Mania charset",
                     "!" & 4 & ";Object",
                     "!" & 18 & ";Object (text file)",
                     "!" & 19 & ";World as text file description",
                     "!" & 20 & ";World as text file desc., with boards","",
                     "ESC to cancel"}, 3)
        if length(result) = 0 then
            return FALSE
        end if
    end if
    
    t_item = result[1]
    
    if t_type = 2 then  -- export
        if t_item = 1 then  -- board
            dummy = SB_Input(SBI_FILENAME, 21, "Filename?.ZBR", 8)
            dummy = dummy & ".zbr"
            f = open(dummy, "wb")
            puts(f, "ZBR000")
            for b = 1 to 16 do
                for c = 1 to 3 do
                    puts(f, BoardProps[CurBoard][BP_PAL][b][c])
                end for
            end for
            for b = 1 to 255 do
                for c = 1 to 16 do
                    puts(f, BoardProps[CurBoard][BP_CHARSET][b][c])
                end for
            end for
            for b = 1 to BOARD_ELEMS do
                puts(f, Boards[CurBoard][b])
            end for
            close(f)
        elsif t_item = 2 then   -- palette
            dummy = SB_Input(SBI_FILENAME, 21, "Filename?.ZPL", 8)
            dummy = dummy & ".zpl"
            f = open(dummy, "w")
            dummy = {}
            for z = 0 to 15 do
                dummy = append(dummy, get_palette(z))
            end for
            print(f, dummy)
            close(f)
        elsif t_item = 3 then   -- charset
            dummy = SB_Input(SBI_FILENAME, 21, "Filename?.ZCH", 8)
            dummy = dummy & ".zch"
            f = open(dummy, "wb")
            for z = 1 to 256 do
                for a = 1 to 16 do
                    puts(f, CharSet[z][a])
                end for
            end for
            close(f)
        elsif t_item = 4 then
            result = DisplayScroll("Export: Object",
                     {"How to select this object?","",
                      "!1;Enter object's @Name",
                      "!2;Select object on current board","",
                      "ESC to cancel"}, 3)
            if length(result) = 0 then
                return FALSE
            else
                dummy = SB_Input(SBI_ANYSTR, 21, "Object name?", 16)
            end if
        end if
    end if
    
    return FALSE
                     
end function

